version: "3"
services:
  ravendb:
    image: ravendb/ravendb:latest
    volumes:
      - ravendb-data:/opt/RavenDB/Server/RavenData
    container_name: ravendb
    ports:
      - "8080:8080"
      - "38888:38888"
    environment:
      RAVEN_Setup_Mode: "None"
      RAVEN_License_Eula_Accepted: "true"   
      
  elasticsearch:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.11.1
    ports:
      - "9200:9200"
      - "9300:9300"
    networks:
      - testes-elastic
    environment:
      discovery.type: single-node
      ES_JAVA_OPTS: "-Xms1g -Xmx1g"
      
  kibana:
    image: docker.elastic.co/kibana/kibana:7.11.1
    ports:
      - "5601:5601"
    networks:
      - testes-elastic
    depends_on:
      - elasticsearch 
        
  apm-server:
    image: docker.elastic.co/apm/apm-server:7.11.1
    ports:
      - "127.0.0.1:${APM_SERVER_PORT:-8200}:8200"
      - "127.0.0.1:${APM_SERVER_MONITOR_PORT:-6060}:6060"
    command: >
      apm-server -e
        -E apm-server.host=0.0.0.0:8200
        -E apm-server.kibana.enabled=true
        -E apm-server.kibana.host=kibana:5601
        -E apm-server.kibana.username=elastic
        -E apm-server.kibana.password=master          
        -E apm-server.rum.enabled=true       
        -E output.elasticsearch.hosts=[elasticsearch:9200]
        -E output.elasticsearch.username=elastic
        -E output.elasticsearch.password=master
    cap_drop:
      - ALL
    cap_add:
      - CHOWN
      - DAC_OVERRIDE
      - SETGID
      - SETUID
    logging:
      driver: 'json-file'
      options:
        max-size: '2m'
        max-file: '5'
    depends_on:
      - elasticsearch
      - kibana
    networks:
      - testes-elastic        
    healthcheck:
      test: ["CMD", "curl", "--write-out", "'HTTP %{http_code}'", "--silent", "--output", "/dev/null", "http://localhost:8200/healthcheck"]
      retries: 10
      interval: 10s

volumes:
  ravendb-data:
    
networks:
  testes-elastic:
    driver: bridge    